//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 10-1 #1
//
// Creates nodes when the user enters an id number. Each node stores the id
// number and a pointer to the next node.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <stdlibm.h>

#define UNUSED 0xFFFF

typedef node * nodeptr;

typedef struct {
   int32 id_number;
   nodeptr next;
} node;

node list[20];
int next_node = 0;
nodeptr first = UNUSED;

void sort_list(void);
nodeptr add_node(int id);
void print_list(void);

void main(void) 
{
   for(;;) {
      printf("Enter ID Number: ");
      list[next_node++] = add_node(get_int_usb());
      sort_list();
      print_list();
   }

   for(;;);
}

nodeptr add_node(int id) {
   nodeptr cur;
   
   cur = (nodeptr)malloc(sizeof(node));
   cur -> id_number = id;
   cur -> next = first;
   first = cur;
   
   
   return cur;
}

void sort_list(void) {
   nodeptr nxt = first -> next;
   nodeptr ptr = first;
   
   while(nxt != UNUSED)
   {
      while((nxt != ptr) && (nxt->id_number < ptr->id_number)) {
         int tmp = ptr->id_number;
         ptr->id_number = nxt->id_number;
         nxt->id_number = tmp;
         ptr = ptr->next;
      }
      ptr = nxt;
      nxt = nxt->next;
   }
}

void print_list(void) {
   nodeptr ptr = first;
   
   while(ptr != UNUSED) {
      printf("\r\n[%d]\r\n", (int)ptr->id_number);
      ptr = ptr -> next;
   }
}
