//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 10-1 #2
//
// Prompts user to enter an R for RAM or P for Program Memory, then for an
// address in hex. It then displays the contents of that memory address in hex.
//
// The first 4K of ROM is read protected, so they can't be read (will always
// return 0).  That means any Program reads under 4096 will always return
// 0.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

void main(void) 
{
   unsigned int8 * ramPtr;
   rom unsigned int8 * romPtr;
   int cmd;

   for(;;) {
      
      do {
         printf("\r\nRAM or Program? (R or P): ");
         cmd = toupper(usb_cdc_getc());
      } while((cmd != 'R') && (cmd != 'P'));
      
      if(cmd == 'R') {
         // Read from RAM
         printf("\r\nEnter RAM Address: ");         
         ramPtr = get_int_usb();
         printf("\r\n%u is at %u", *ramPtr, (unsigned int8)ramPtr);
      }
      else {
         // Read from Program
         printf("\r\nEnter ROM Address: ");
         romPtr = get_long_usb();
         printf("\r\n%u is at %lu", *romPtr, (unsigned int16)romPtr);
      }
   }

   for(;;);
}
